## multipath-tools 0.9.7

=== multipath/Makefile ===
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@opensvc.com>
#
include ../Makefile.inc

EXEC      := multipath
MANPAGES  := multipath.8 multipath.conf.5
GENERATED := $(MANPAGES) multipath.rules tmpfiles.conf

CPPFLAGS += -I$(multipathdir) -I$(mpathutildir) -I$(mpathcmddir)
CFLAGS += $(BIN_CFLAGS)
LDFLAGS += $(BIN_LDFLAGS)
LIBDEPS += -L$(multipathdir) -lmultipath -L$(mpathutildir) -lmpathutil \
	-L$(mpathcmddir) -lmpathcmd -lpthread -ldevmapper -ldl -ludev

OBJS := main.o

all: $(EXEC) $(GENERATED)

$(EXEC): $(OBJS) $(multipathdir)/libmultipath.so $(mpathcmddir)/libmpathcmd.so
	@echo building $@ because of $?
	$(Q)$(CC) $(CFLAGS) $(OBJS) -o $(EXEC) $(LDFLAGS) $(LIBDEPS)

install:
	$(Q)$(INSTALL_PROGRAM) -d $(DESTDIR)$(bindir)
	$(Q)$(INSTALL_PROGRAM) -m 755 $(EXEC) $(DESTDIR)$(bindir)/
	$(Q)$(INSTALL_PROGRAM) -d $(DESTDIR)$(udevrulesdir)
	$(Q)$(INSTALL_PROGRAM) -m 644 11-dm-mpath.rules $(DESTDIR)$(udevrulesdir)
	$(Q)$(INSTALL_PROGRAM) -m 644 multipath.rules $(DESTDIR)$(udevrulesdir)/56-multipath.rules
	$(Q)$(INSTALL_PROGRAM) -d $(DESTDIR)$(tmpfilesdir)
	$(Q)$(INSTALL_PROGRAM) -m 644 tmpfiles.conf $(DESTDIR)$(tmpfilesdir)/multipath.conf
	$(Q)$(INSTALL_PROGRAM) -d $(DESTDIR)$(mandir)/man8
	$(Q)$(INSTALL_PROGRAM) -m 644 $(EXEC).8 $(DESTDIR)$(mandir)/man8
	$(Q)$(INSTALL_PROGRAM) -d $(DESTDIR)$(mandir)/man5
	$(Q)$(INSTALL_PROGRAM) -m 644 $(EXEC).conf.5 $(DESTDIR)$(mandir)/man5
	$(Q)$(INSTALL_PROGRAM) -d $(DESTDIR)$(modulesloaddir)
ifeq ($(MODPROBE_UNIT),)
	$(Q)$(INSTALL_PROGRAM) -m 644 modules-load.conf $(DESTDIR)$(modulesloaddir)/multipath.conf
endif
ifneq ($(SCSI_DH_MODULES_PRELOAD),)
	$(Q)$(INSTALL_PROGRAM) -m 644 scsi_dh.conf $(DESTDIR)$(modulesloaddir)/scsi_dh.conf
	$(Q)for _x in $(SCSI_DH_MODULES_PRELOAD); do echo "$$_x"; done \
	    >>$(DESTDIR)$(modulesloaddir)/scsi_dh.conf
endif

uninstall:
	$(Q)$(RM) $(DESTDIR)$(bindir)/$(EXEC)
	$(Q)$(RM) $(DESTDIR)$(udevrulesdir)/11-dm-mpath.rules
	$(Q)$(RM) $(DESTDIR)$(modulesloaddir)/multipath.conf
	$(Q)$(RM) $(DESTDIR)$(modulesloaddir)/scsi_dh.conf
	$(Q)$(RM) $(DESTDIR)$(libudevdir)/rules.d/56-multipath.rules
	$(Q)$(RM) $(DESTDIR)$(mandir)/man8/$(EXEC).8
	$(Q)$(RM) $(DESTDIR)$(mandir)/man5/$(EXEC).conf.5
	$(Q)$(RM) $(DESTDIR)$(tmpfilesdir)/multipath.conf

clean: dep_clean
	$(Q)$(RM) core *.o $(EXEC) $(GENERATED)

include $(wildcard $(OBJS:.o=.d))

dep_clean:
	$(Q)$(RM) $(OBJS:.o=.d)

=== tests/Makefile ===
include ../Makefile.inc

# directory where to run the tests
TESTDIR := $(CURDIR)

CPPFLAGS += -I$(multipathdir) -I$(mpathutildir) -I$(mpathcmddir) -I$(daemondir) \
	-DTESTCONFDIR=\"$(TESTDIR)/conf.d\"
CFLAGS += $(BIN_CFLAGS) -Wno-unused-parameter $(W_MISSING_INITIALIZERS)
LIBDEPS += -L. -L $(mpathutildir) -L$(mpathcmddir) -lmultipath -lmpathutil -lmpathcmd -lcmocka

TESTS := uevent parser util dmevents hwtable blacklist unaligned vpd pgpolicy \
	 alias directio valid devt mpathvalid strbuf sysfs features cli
HELPERS := test-lib.o test-log.o

.PRECIOUS: $(TESTS:%=%-test)

all:	$(TESTS:%=%.out)
progs:	$(TESTS:%=%-test) lib/libchecktur.so
valgrind:	$(TESTS:%=%.vgr)

# test-specific compiler flags
# XYZ-test_FLAGS: Additional compiler flags for this test

ifneq ($(wildcard directio_test_dev),)
DIO_TEST_DEV = $(shell sed -n -e 's/^[[:space:]]*DIO_TEST_DEV[[:space:]]*=[[:space:]]*\([^[:space:]\#]\+\).*/\1/p' < directio_test_dev)
endif
ifneq ($(DIO_TEST_DEV),)
directio-test_FLAGS := -DDIO_TEST_DEV=\"$(DIO_TEST_DEV)\"
endif
mpathvalid-test_FLAGS := -I$(mpathvaliddir)
features-test_FLAGS := -I$(multipathdir)/nvme

# test-specific linker flags
# XYZ-test_TESTDEPS: test libraries containing __wrap_xyz functions
# XYZ-test_OBJDEPS: object files from libraries to link in explicitly
#    That may be necessary if functions called from the object file are wrapped
#    (wrapping works only for symbols which are undefined after processing a
#    linker input file).
#    Some object files, e.g. "config.o", are compiled separately for the
#    unit tests. Look for OBJS-U in libmultipath/Makefile. Make sure to use the
#    unit test file, e.g. "config-test.o", in XYZ-test_OBJDEPS
# XYZ-test_LIBDEPS: Additional libs to link for this test

dmevents-test_OBJDEPS = $(multipathdir)/devmapper.o
dmevents-test_LIBDEPS = -lpthread -ldevmapper -lurcu
hwtable-test_TESTDEPS := test-lib.o
hwtable-test_OBJDEPS := $(multipathdir)/discovery.o $(multipathdir)/blacklist.o \
	$(multipathdir)/structs.o $(multipathdir)/propsel.o
hwtable-test_LIBDEPS := -ludev -lpthread -ldl
blacklist-test_TESTDEPS := test-log.o
blacklist-test_LIBDEPS := -ludev
vpd-test_OBJDEPS :=  $(multipathdir)/discovery.o
vpd-test_LIBDEPS := -ludev -lpthread -ldl
alias-test_TESTDEPS := test-log.o
alias-test_OBJDEPS := $(mpathutildir)/util.o
alias-test_LIBDEPS := -lpthread -ldl
valid-test_OBJDEPS := $(multipathdir)/valid.o $(multipathdir)/discovery.o
valid-test_LIBDEPS := -lmount -ludev -lpthread -ldl
devt-test_LIBDEPS := -ludev
mpathvalid-test_LIBDEPS := -ludev -lpthread -ldl
mpathvalid-test_OBJDEPS := $(mpathvaliddir)/mpath_valid.o
ifneq ($(DIO_TEST_DEV),)
directio-test_LIBDEPS := -laio
endif
strbuf-test_OBJDEPS := $(mpathutildir)/strbuf.o
sysfs-test_TESTDEPS := test-log.o
sysfs-test_OBJDEPS := $(multipathdir)/sysfs.o $(mpathutildir)/util.o
sysfs-test_LIBDEPS := -ludev -lpthread -ldl
features-test_LIBDEPS := -ludev -lpthread
cli-test_OBJDEPS := $(daemondir)/cli.o

%.o: %.c
	@echo building $@ because of $?
	$(Q)$(CC) $(CPPFLAGS) $(CFLAGS) $($*-test_FLAGS) -c -o $@ $<

lib/libchecktur.so:
	@mkdir -p lib
	$(Q)cd lib && ln -s ../$(multipathdir)/*/*.so .

%.out:	%-test lib/libchecktur.so
	@echo == running $< ==
	@LD_LIBRARY_PATH=.:$(mpathutildir):$(mpathcmddir) ./$< >$@ 2>&1 || { cat "$@"; false; }

%.vgr:  %-test lib/libchecktur.so
	@echo == running valgrind for $< ==
	@LD_LIBRARY_PATH=.:$(mpathutildir):$(mpathcmddir) \
		valgrind --leak-check=full --error-exitcode=128 ./$< >$@ 2>&1

OBJS = $(TESTS:%=%.o) $(HELPERS)

test_clean:
	$(Q)$(RM) $(TESTS:%=%.out) $(TESTS:%=%.vgr) *.so*

valgrind_clean:
	$(Q)$(RM) $(TESTS:%=%.vgr)

clean: test_clean valgrind_clean dep_clean
	$(Q)$(RM) $(TESTS:%=%-test) $(OBJS) *.o.wrap
	$(Q)$(RM) -rf lib conf.d

.SECONDARY: $(OBJS)

include $(wildcard $(OBJS:.o=.d))

dep_clean:
	$(Q)$(RM) $(OBJS:.o=.d)

%.o.wrap:	%.c
	@sed -n 's/^.*__wrap_\([a-zA-Z0-9_]*\).*$$/-Wl,--wrap=\1/p' $< | \
		sort -u | tr '\n' ' ' >$@

# Pass the original values of CFLAGS etc. to the sub-make, which will include
# Makefile.in again. Otherwise, the flags would be added twice.
libmultipath.so.0: $(multipathdir)/libmultipath.so.0
	@CFLAGS="$(ORIG_CFLAGS)" CPPFLAGS="$(ORIG_CPPFLAGS)" LDFLAGS="$(ORIG_LDFLAGS)" \
	$(MAKE) -C $(multipathdir) configdir=$(TESTDIR)/conf.d plugindir=$(TESTDIR)/lib test-lib

# COLON will get expanded during second expansion below
COLON:=:
.SECONDEXPANSION:
%-test:	%.o %.o.wrap $$($$@_OBJDEPS) $$($$@_TESTDEPS) $$($$@_TESTDEPS$$(COLON).o=.o.wrap) \
		libmultipath.so.0 $(mpathutildir)/libmpathutil.so.0 $(mpathcmddir)/libmpathcmd.so.0 Makefile
	@echo building $@
	$(Q)$(CC) $(CFLAGS) -o $@ $(LDFLAGS) $< $($@_TESTDEPS) $($@_OBJDEPS) \
		$(LIBDEPS) $($@_LIBDEPS) \
		$(shell cat $<.wrap) $(foreach dep,$($@_TESTDEPS),$(shell cat $(dep).wrap))

=== debian/changelog ===
multipath-tools (0.9.7-7ubuntu1) oracular; urgency=medium

  * Merge from Debian unstable.  Remaining changes:
    - d/multipath.conf: Install friendly names multipath.conf by default,
      instead of generating it in every installer.
    - d/rules: Move udev rules to priority 95, because rules that load
      modules should be >90.
    - d/rules: remove -Bsymbolic-functions from LDFLAGS
      (https://github.com/opensvc/multipath-tools/issues/26)
    - Don't build the multipath-tools binary package on i386; only kpartx.
    - Split kpartx initramfs bits into kpartx-boot for dmraid (LP 941874)
      + d/kpartx-initramfs/hooks/kpartx
      + d/kpartx-boot.install
      + d/kpartx-boot.postinst
      + d/kpartx-boot.postrm
      + d/control: Add kpartx-boot package for dmraid
    - d/p/enable-find-multipaths.patch: re-enable find_multipaths by
      default
  * Dropped changes, included in Debian:
    - d/initramfs/hooks: also copy wwids file on the installed
      system to ensure all paths come up on boot.
    - d/initramfs/hooks: do not copy kpartx rules to initramfs
    - d/initramfs/hooks: install multipathd and required directories.
    - d/initramfs/hooks: copy multipath udev rules to initramfs
    - Remove d/initramfs/local-top (redundant with other initramfs scripts):
      + init-top: take over loading modules (dm-multipath and SCSI device
        handlers); move the missing dm-emc there (now scsi-dh-emc)
      + remove d/initramfs/local-top
    - multipath initramfs fixes for booting from multipathed devices:
      + d/initramfs/local-bottom: remember to stop multipathd.
      + d/initramfs/local-premount: wait for udev to settle before
        the call to resolve_device() in local_mount_root(), so the
        by-uuid/ symlinks have a chance to be updated by the
        multipath udev rules.
      + d/initramfs/local-premount: Run multipath with -B so not to
        assign names nor change /etc/multipath/bindings during
        initramfs
    - d/rules: do not install init scripts
    - d/multipath-tools.maintscript: remove /etc/init.d/multipath-tools
    - Remove wrong hard-coded dep on libaio1.
  * Dropped changes, no longer needed:
    - d/initramfs/hooks: Add dm-queue-length
    - d/multipath-tools.dm-mpath-lvm.udev: local udev rule hasn't been
      shipped since at least jammy

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 05 Jun 2024 14:24:55 -0700

multipath-tools (0.9.7-7) unstable; urgency=medium

  * [9d90323] Drop hard-coded dependency on libaio1 (Closes: #1068944)

 -- Chris Hofstaedtler <zeha@debian.org>  Sun, 14 Apr 2024 13:04:31 +0200

multipath-tools (0.9.7-6) unstable; urgency=medium

  * [85ca059] Switch Build-Depends pkg-config to pkgconf

 -- Chris Hofstaedtler <zeha@debian.org>  Thu, 29 Feb 2024 22:38:43 +0100

multipath-tools (0.9.7-5) unstable; urgency=medium

  * [902a13b] Rely on newly un-broken dmsetup 2:1.02.196-1

 -- Chris Hofstaedtler <zeha@debian.org>  Thu, 29 Feb 2024 22:35:59 +0100

multipath-tools (0.9.7-4) unstable; urgency=medium

  * [2faddfc] Fix initramfs test

 -- Chris Hofstaedtler <zeha@debian.org>  Wed, 31 Jan 2024 18:05:03 +0100

multipath-tools (0.9.7-3) unstable; urgency=medium

  * [b7f0988] Switch Build-Depends to systemd-dev (Closes: #1060604)

 -- Chris Hofstaedtler <zeha@debian.org>  Fri, 12 Jan 2024 13:21:59 +0100

multipath-tools (0.9.7-2) unstable; urgency=medium

  * [018f436] Correctly apply Debian-specific udev rule priorities

 -- Chris Hofstaedtler <zeha@debian.org>  Thu, 04 Jan 2024 20:32:14 +0100

multipath-tools (0.9.7-1) unstable; urgency=medium

  * [232dd6e] New upstream version 0.9.7
  * [ed5de58] Refresh patches
  * [97e9782] Build-Depend: libmount-dev, now needed
  * [462750d] Follow upstream change from modules-load to modprobe@ service
  * [46cd7fe] d/rules: drop SCSI_DH_MODULES_PRELOAD which did not work anyway
  * [5ec6ee3] autopkgtest: add extra details, journal output
  * [11f09a7] postinst: ignore failure from udevadm

 -- Chris Hofstaedtler <zeha@debian.org>  Thu, 04 Jan 2024 00:19:37 +0100

multipath-tools (0.9.4-10) unstable; urgency=medium

  * [ff4b063] Fix udev rules install location
  * [704cf13] autopkgtest: fix under upstream default of find_multipaths strict

 -- Chris Hofstaedtler <zeha@debian.org>  Mon, 01 Jan 2024 20:21:16 +0100

multipath-tools (0.9.4-9) unstable; urgency=medium

  * Upload to unstable.
  * [c785707] Rearrange debian/tmp usage to get more out of dh_missng
  * [05a2082] Use dh_install to install udev rules
  * [6c4f974] kpartx-udeb: install udev rules and helper (Closes: #1059747)
  * [5598a12] initramfs: use /usr-merged layout
  * [d41422b] initramfs: use modern helpers, tidy up
  * [bdcbd1e] Stop installing multipath-tools-boot.service mask
  * [13d5c3e] Refresh patches
  * [265cc4d] Apply wrap-and-sort -kast
  * [a42a18b] Add new autopkgtest for initramfs hooks

 -- Chris Hofstaedtler <zeha@debian.org>  Mon, 01 Jan 2024 17:31:35 +0100

multipath-tools (0.9.4-8) experimental; urgency=medium

  * Target experimental.
  * [dfcb2a2] Install into /usr-merged layout

 -- Chris Hofstaedtler <zeha@debian.org>  Sat, 23 Dec 2023 20:20:34 +0100

multipath-tools (0.9.4-7) unstable; urgency=medium

  * [bdc80b9] Merge initramfs integration from Ubuntu.
    Which apparently got updated since the 0.7.x days, compared to ours.
    Keep kpartx in the multipath hook, as we do not have a separate kpartx-boot
    package, and likely never will.
  * [918d442] Remove init script, following Ubuntu bug reports
  * [475fd45] Drop obsolete Depends: lsb-base
  * [bc3bacb] Add NEWS for updated boot, removed sysvinit scripts

 -- Chris Hofstaedtler <zeha@debian.org>  Sat, 11 Nov 2023 00:44:56 +0100

multipath-tools (0.9.4-6) unstable; urgency=medium

  [ Sergio Durigan Junior ]
  * [818e429] d/p/0007-multipathd.service-remove-Also-multipathd.socket.patch:
    Remove "Also=multipathd.socket" from multipathd.service, which was
    breaking socket-activation.


=== debian/control ===
Source: multipath-tools
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian DM Multipath Team <team+linux-blocks@tracker.debian.org>
Uploaders:
 Guido Günther <agx@sigxcpu.org>,
 Ritesh Raj Sarraf <rrs@debian.org>,
 Chris Hofstaedtler <zeha@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 libaio-dev,
 libdevmapper-dev,
 libedit-dev,
 libmount-dev,
 libjson-c-dev,
 libsystemd-dev,
 libudev-dev,
 liburcu-dev,
 pkgconf,
 systemd-dev,
Vcs-Git: https://salsa.debian.org/linux-blocks-team/multipath-tools.git
Vcs-Browser: https://salsa.debian.org/linux-blocks-team/multipath-tools
Standards-Version: 3.9.8
Homepage: http://christophe.varoqui.free.fr/
Rules-Requires-Root: no

Package: multipath-tools
Architecture: linux-any
Depends:
 kpartx (>= ${binary:Version}),
 sg3-utils-udev,
 udev,
# need systemd >= 245 for modprobe@dm_multipath.service
 systemd (>= 245~),
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Suggests:
 multipath-tools-boot,
Description: maintain multipath block device access
 These tools are in charge of maintaining the disk multipath device maps and
 react to path and map events.
 .
 If you install this package you may have to change the way you address block
 devices. See README.Debian for details.

Package: kpartx
Architecture: linux-any
Depends:
# need dmsetup >= 2:1.02.196-1 to get non-broken DM_UDEV_RULES_VSN in their udev rules
 dmsetup (>= 2:1.02.196-1~),
 udev,
 ${misc:Depends},
 ${shlibs:Depends},
Description: create device mappings for partitions
 Kpartx can be used to set up device mappings for the partitions of any
 partitioned block device.
 .
 It is part of the Linux multipath-tools, but is useful on any
 device-mapper using system.

Package: kpartx-boot
Architecture: all
Depends: ${misc:Depends}, initramfs-tools,
 kpartx (>= ${source:Version}), kpartx (<< ${source:Version}.1~)
Description: Provides kpartx during boot
 This package makes kpartx available during boot to activate partitions

Package: multipath-tools-boot
Architecture: all
Depends:
 initramfs-tools | linux-initramfs-tool,
 kpartx-boot (= ${binary:Version}),
 multipath-tools (<< ${source:Version}.1~),
 multipath-tools (>= ${source:Version}),
 ${misc:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Description: Support booting from multipath devices
 This package contains the necessary support for booting from a multipath
 device:
 .
  * copy over multipath.conf and persistent bindings if necessary
  * load the necessary kernel modules
  * detect multipath block devices
 .
 Don't install this package if you're not booting from a multipath device.

Package: multipath-udeb
Package-Type: udeb
Architecture: linux-any
Depends:
 kpartx-udeb,
 multipath-modules,
 ${misc:Depends},
 ${shlibs:Depends},
Section: debian-installer
Description: maintain multipath block device access - udeb package
 This is a udeb, or a microdeb, for the debian-installer.
 .
 These tools are in charge of maintaining the disk multipath device maps and
 react to path and map events.

Package: kpartx-udeb
Package-Type: udeb
Architecture: linux-any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Section: debian-installer
Description: create device mappings for partitions - udeb package
 This is a udeb, or a microdeb, for the debian-installer.
 .
 Kpartx can be used to set up device mappings for the partitions of any
 partitioned block device. It is part of the Linux multipath-tools.

=== debian/rules ===
#!/usr/bin/make -f

ifeq ($(shell dpkg-architecture -qDEB_HOST_ARCH),i386)
	skip_packages = -Nmultipath-tools
endif

# For Hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_STRIP=-Wl,-Bsymbolic-functions
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk

# Reproducible timestamp
export KBUILD_BUILD_TIMESTAMP = "@$(SOURCE_DATE_EPOCH)"

# Disable libdmmp, no known users exist
export ENABLE_LIBDMMP=0

TREENAMES = build-deb build-udeb

%:
	dh $@

execute_before_dh_clean:
	for treename in $(TREENAMES); do \
		rm -rf debian/$$treename ;\
	done
	# Force recreation of docs re. reproducibility
	rm -fv libdmmp/docs/man/dmmp_strerror.3

execute_before_dh_auto_configure:
	# no out of tree build support, prepare two source trees
	for treename in $(TREENAMES); do \
		mkdir debian/$$treename ;\
		cp -r -t debian/$$treename $$(find . -mindepth 1 -maxdepth 1 \! -name debian \! -name .git) ;\
	done

override_dh_auto_configure:

override_dh_auto_build:
	dh_auto_build --sourcedirectory=debian/build-deb
	# multipath-udeb: build separately; don't reference dynamic libgcc at runtime (#779579); disable systemd
	dh_auto_build --sourcedirectory=debian/build-udeb -- \
		SYSTEMD= EXTRACFLAGS="-static-libgcc"

override_dh_auto_test:

override_dh_auto_install:
	dh_auto_install --sourcedirectory=debian/build-deb -- DESTDIR=$(CURDIR)/debian/tmp/deb
	dh_auto_install --sourcedirectory=debian/build-udeb -- DESTDIR=$(CURDIR)/debian/tmp/udeb

	mkdir -p $(CURDIR)/debian/tmp/deb/etc
	cp debian/multipath.conf $(CURDIR)/debian/tmp/deb/etc

	# udebs dont get manpages
	rm -rf $(CURDIR)/debian/tmp/udeb/usr/share/man

	# Delete development files to prevent accidential linking of libraries with unlikely-to-be-stable ABI.
	rm \
		$(CURDIR)/debian/tmp/deb/usr/include/mpath_cmd.h \
		$(CURDIR)/debian/tmp/deb/usr/include/mpath_persist.h \
		$(CURDIR)/debian/tmp/udeb/usr/include/mpath_cmd.h \
		$(CURDIR)/debian/tmp/udeb/usr/include/mpath_persist.h \
		$(CURDIR)/debian/tmp/deb/usr/share/man/man3/mpath_persistent* \
		$(CURDIR)/debian/tmp/deb/usr/lib/libm*.so \
		$(CURDIR)/debian/tmp/udeb/usr/lib/libm*.so

execute_after_dh_install:
	if strings debian/multipath-udeb/usr/lib/libmultipath.so.0 | grep libsystemd.so ; then \
		echo ERROR: udeb linked to libsystemd ;\
		exit 1 ;\
	fi

override_dh_bugfiles:
	dh_bugfiles -A -pmultipath-tools -pmultipath-tools-boot

override_dh_installudev:
	dh_installudev -pkpartx --priority=95
	dh_installudev -pkpartx --name=dm-parts --priority=56
	dh_installudev -pkpartx --name=del-part-nodes --priority=68
	dh_installudev -pmultipath-tools --name=multipath
	dh_installudev -pmultipath-tools --name=dm-mpath --priority=56

override_dh_installsystemd:
	# Don't auto-enable/start the service; instead, rely on
	# socket-activation.
	dh_installsystemd -pmultipath-tools multipathd.service \
		--no-stop-on-upgrade --no-enable
	dh_installsystemd -pmultipath-tools multipathd.socket

override_dh_makeshlibs:
	dh_makeshlibs -a --add-udeb=multipath-udeb

override_dh_builddeb:
	dh_builddeb ${skip_packages}

override_dh_gencontrol:
	dh_gencontrol ${skip_packages}

## multipath-tools 0.9.9

=== kpartx/Makefile ===
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@opensvc.com>
#
include ../Makefile.inc

EXEC := kpartx

CPPFLAGS += -I. -I$(multipathdir) -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64
CFLAGS += $(BIN_CFLAGS)
LDFLAGS += $(BIN_LDFLAGS)
LIBDEPS += -ldevmapper

OBJS := bsd.o dos.o kpartx.o solaris.o unixware.o dasd.o sun.o \
	gpt.o mac.o ps3.o crc32.o lopart.o xstrncpy.o devmapper.o

all: $(EXEC)

$(EXEC): $(OBJS)
	@echo building $@ because of $?
	$(Q)$(CC) $(CFLAGS) $(OBJS) -o $(EXEC) $(LDFLAGS) $(LIBDEPS)

install: $(EXEC) $(EXEC).8
	$(Q)$(INSTALL_PROGRAM) -d $(DESTDIR)$(bindir)
	$(Q)$(INSTALL_PROGRAM) -m 755 $(EXEC) $(DESTDIR)$(bindir)
	$(Q)$(INSTALL_PROGRAM) -d $(DESTDIR)$(libudevdir)
	$(Q)$(INSTALL_PROGRAM) -m 755 kpartx_id $(DESTDIR)$(libudevdir)
	$(Q)$(INSTALL_PROGRAM) -d $(DESTDIR)$(libudevdir)/rules.d
	$(Q)$(INSTALL_PROGRAM) -m 644 dm-parts.rules $(DESTDIR)$(libudevdir)/rules.d/11-dm-parts.rules
	$(Q)$(INSTALL_PROGRAM) -m 644 kpartx.rules $(DESTDIR)$(libudevdir)/rules.d/66-kpartx.rules
	$(Q)$(INSTALL_PROGRAM) -m 644 del-part-nodes.rules $(DESTDIR)$(libudevdir)/rules.d/68-del-part-nodes.rules
	$(Q)$(INSTALL_PROGRAM) -d $(DESTDIR)$(mandir)/man8
	$(Q)$(INSTALL_PROGRAM) -m 644 $(EXEC).8 $(DESTDIR)$(mandir)/man8

uninstall:
	$(Q)$(RM) $(DESTDIR)$(bindir)/$(EXEC)
	$(Q)$(RM) $(DESTDIR)$(mandir)/man8/$(EXEC).8
	$(Q)$(RM) $(DESTDIR)$(libudevdir)/kpartx_id
	$(Q)$(RM) $(DESTDIR)$(libudevdir)/rules.d/11-dm-parts.rules
	$(Q)$(RM) $(DESTDIR)$(libudevdir)/rules.d/66-kpartx.rules
	$(Q)$(RM) $(DESTDIR)$(libudevdir)/rules.d/67-kpartx-compat.rules
	$(Q)$(RM) $(DESTDIR)$(libudevdir)/rules.d/68-del-part-nodes.rules

clean: dep_clean
	$(Q)$(RM) core *.o $(EXEC)

include $(wildcard $(OBJS:.o=.d))

dep_clean:
	$(Q)$(RM) $(OBJS:.o=.d)

=== libmpathpersist/Makefile ===
include ../Makefile.inc

DEVLIB := libmpathpersist.so
CFLAGS += $(LIB_CFLAGS) -I$(multipathdir) -I$(mpathutildir) -I$(mpathpersistdir) -I$(mpathcmddir)
LDFLAGS += -L$(multipathdir) -L$(mpathutildir) -L$(mpathcmddir)
LIBDEPS += -lmultipath -lmpathutil -lmpathcmd -ldevmapper -lpthread -ldl

OBJS := mpath_persist.o mpath_updatepr.o mpath_pr_ioctl.o mpath_persist_int.o

all: $(DEVLIB)

include $(TOPDIR)/rules.mk

install: all
	$(Q)$(INSTALL_PROGRAM) -d $(DESTDIR)$(syslibdir)
	$(Q)$(INSTALL_PROGRAM) -m 755 $(LIBS) $(DESTDIR)$(syslibdir)/$(LIBS)
	$(Q)$(INSTALL_PROGRAM) -m 755 -d $(DESTDIR)$(syslibdir)
	$(Q)$(INSTALL_PROGRAM) -m 755 -d $(DESTDIR)$(mandir)/man3
	$(Q)$(INSTALL_PROGRAM) -m 755 -d $(DESTDIR)$(includedir)
	$(Q)$(LN) $(LIBS) $(DESTDIR)$(syslibdir)/$(DEVLIB)
	$(Q)$(INSTALL_PROGRAM) -m 644 mpath_persistent_reserve_in.3 $(DESTDIR)$(mandir)/man3
	$(Q)$(INSTALL_PROGRAM) -m 644 mpath_persistent_reserve_out.3 $(DESTDIR)$(mandir)/man3
	$(Q)$(INSTALL_PROGRAM) -m 644 mpath_persist.h $(DESTDIR)$(includedir)

uninstall:
	$(Q)$(RM) $(DESTDIR)$(syslibdir)/$(LIBS)
	$(Q)$(RM) $(DESTDIR)$(mandir)/man3/mpath_persistent_reserve_in.3
	$(Q)$(RM) $(DESTDIR)$(mandir)/man3/mpath_persistent_reserve_out.3
	$(Q)$(RM) $(DESTDIR)$(includedir)/mpath_persist.h
	$(Q)$(RM) $(DESTDIR)$(syslibdir)/$(DEVLIB)

clean: dep_clean
	$(Q)$(RM) core *.a *.o *.so *.so.* *.abi $(NV_VERSION_SCRIPT)

include $(wildcard $(OBJS:.o=.d))


dep_clean:
	$(Q)$(RM) $(OBJS:.o=.d)

=== multipathd/Makefile ===
include ../Makefile.inc

EXEC     := multipathd
CLI      := multipathc
MANPAGES := multipathd.8

CPPFLAGS += -I$(multipathdir) -I$(mpathutildir) -I$(mpathpersistdir) -I$(mpathcmddir) -I$(thirdpartydir) \
	-DBINDIR='"$(bindir)"' $(SYSTEMD_CPPFLAGS)

#
# debugging stuff
#
#CPPFLAGS += -DLCKDBG
#CPPFLAGS += -DLOGDBG

CFLAGS += $(BIN_CFLAGS)
LDFLAGS += $(BIN_LDFLAGS)

CLI_LIBDEPS	:=  -L$(mpathutildir) -lmpathutil -L$(mpathcmddir) -lmpathcmd \
		-ludev -ldl -lurcu -lpthread $(SYSTEMD_LIBDEPS)
LIBDEPS		:= -L$(multipathdir) -lmultipath -L$(mpathpersistdir) -lmpathpersist \
	  	-ldevmapper $(CLI_LIBDEPS)

ifeq ($(READLINE),libedit)
RL_CPPFLAGS	:= -DUSE_LIBEDIT
RL_LIBDEPS	:= -ledit
# See comment in multipathc.c
ifeq ($(shell sed -En 's/.*\<Function\s*\*rl_completion_entry_function;.*/yes/p' /usr/include/editline/readline.h),yes)
RL_CPPFLAGS += -DBROKEN_RL_COMPLETION_FUNC
endif
endif
ifeq ($(READLINE),libreadline)
RL_CPPFLAGS	:= -DUSE_LIBREADLINE
RL_LIBDEPS	:= -lreadline
endif

CLI_OBJS := multipathc.o cli.o
OBJS := main.o pidfile.o uxlsnr.o uxclnt.o cli.o cli_handlers.o waiter.o \
       dmevents.o init_unwinder.o
ifeq ($(FPIN_SUPPORT),1)
OBJS += fpin_handlers.o
endif

all : $(EXEC) $(CLI) $(MANPAGES) $(EXEC).service

$(EXEC): $(OBJS) $(multipathdir)/libmultipath.so $(mpathcmddir)/libmpathcmd.so
	@echo building $@ because of $?
	$(Q)$(CC) $(CFLAGS) $(OBJS) $(LDFLAGS) -o $(EXEC) $(LIBDEPS)

multipathc.o:	multipathc.c
	$(Q)$(CC) $(CPPFLAGS) $(RL_CPPFLAGS) $(CFLAGS) -Wno-unused-parameter -c -o $@ $<

$(CLI):  $(CLI_OBJS)
	@echo building $@ because of $?
	$(Q)$(CC) $(CFLAGS) $(CLI_OBJS) $(LDFLAGS) -o $@ $(CLI_LIBDEPS) $(RL_LIBDEPS)

cli_handlers.o:	cli_handlers.c
	$(Q)$(CC) $(CPPFLAGS) $(CFLAGS) -Wno-unused-parameter -c -o $@ $<

install:
	$(Q)$(INSTALL_PROGRAM) -d $(DESTDIR)$(bindir)
	$(Q)$(INSTALL_PROGRAM) -m 755 $(EXEC) $(DESTDIR)$(bindir)
	$(Q)$(INSTALL_PROGRAM) -m 755 $(CLI) $(DESTDIR)$(bindir)
ifdef SYSTEMD
	$(Q)$(INSTALL_PROGRAM) -d $(DESTDIR)$(unitdir)
	$(Q)$(INSTALL_PROGRAM) -m 644 $(EXEC).service $(DESTDIR)$(unitdir)
	$(Q)$(INSTALL_PROGRAM) -m 644 $(EXEC).socket $(DESTDIR)$(unitdir)
endif
	$(Q)$(INSTALL_PROGRAM) -d $(DESTDIR)$(mandir)/man8
	$(Q)$(INSTALL_PROGRAM) -m 644 $(EXEC).8 $(DESTDIR)$(mandir)/man8
	$(Q)$(INSTALL_PROGRAM) -m 644 $(CLI).8 $(DESTDIR)$(mandir)/man8

uninstall:
	$(Q)$(RM) $(DESTDIR)$(bindir)/$(EXEC) $(DESTDIR)$(bindir)/$(CLI)
	$(Q)$(RM) $(DESTDIR)$(mandir)/man8/$(EXEC).8
	$(Q)$(RM) $(DESTDIR)$(mandir)/man8/$(CLI).8
	$(Q)$(RM) $(DESTDIR)$(unitdir)/$(EXEC).service
	$(Q)$(RM) $(DESTDIR)$(unitdir)/$(EXEC).socket

clean: dep_clean
	$(Q)$(RM) core *.o $(EXEC) $(CLI) $(MANPAGES) $(EXEC).service

include $(wildcard $(OBJS:.o=.d) $(CLI_OBJS:.o=.d))

dep_clean:
	$(Q)$(RM) $(OBJS:.o=.d) $(CLI_OBJS:.o=.d)

=== tests/Makefile ===
--- 
+++ 
@@ -45,7 +45,7 @@
 dmevents-test_LIBDEPS = -lpthread -ldevmapper -lurcu
 hwtable-test_TESTDEPS := test-lib.o
 hwtable-test_OBJDEPS := $(multipathdir)/discovery.o $(multipathdir)/blacklist.o \
-	$(multipathdir)/structs.o $(multipathdir)/propsel.o
+	$(multipathdir)/structs_vec.o $(multipathdir)/structs.o $(multipathdir)/propsel.o
 hwtable-test_LIBDEPS := -ludev -lpthread -ldl
 blacklist-test_TESTDEPS := test-log.o
 blacklist-test_LIBDEPS := -ludev
@@ -105,8 +105,11 @@
 dep_clean:
 	$(Q)$(RM) $(OBJS:.o=.d)
 
+# Parse the C code for __wrap_xyz() functions and generate linker options from them.
+# See comment in wrap64.h
 %.o.wrap:	%.c
-	@sed -n 's/^.*__wrap_\([a-zA-Z0-9_]*\).*$$/-Wl,--wrap=\1/p' $< | \
+	$(Q)$(CC) $(OPTFLAGS) $(CPPFLAGS) $($*-test_FLAGS) -E $< | \
+		sed -n 's/^.*__wrap_\([a-zA-Z0-9_]*\).*$$/-Wl,--wrap=\1/p' | \
 		sort -u | tr '\n' ' ' >$@
 
 # Pass the original values of CFLAGS etc. to the sub-make, which will include

=== libmultipath/prioritizers/Makefile ===
#
# Copyright (C) 2007 Christophe Varoqui, <christophe.varoqui@opensvc.com>
#
TOPDIR=../..

include ../../Makefile.inc

CPPFLAGS += -I$(multipathdir) -I$(mpathutildir)
CFLAGS += $(LIB_CFLAGS)
LDFLAGS += -L$(multipathdir) -L$(mpathutildir)
LIBDEPS = -lmultipath -lmpathutil -lm -lpthread -lrt

# If you add or remove a prioritizer also update multipath/multipath.conf.5
LIBS = \
	libprioalua.so \
	libprioconst.so \
	libpriodatacore.so \
	libprioemc.so \
	libpriohds.so \
	libpriohp_sw.so \
	libprioiet.so \
	libprioontap.so \
	libpriorandom.so \
	libpriordac.so \
	libprioweightedpath.so \
	libpriopath_latency.so \
	libpriosysfs.so

ifeq ($(ANA_SUPPORT),1)
	LIBS += libprioana.so
	CPPFLAGS += -I../nvme
endif

all: $(LIBS)

libprio%.so: %.o
	$(Q)$(CC) $(LDFLAGS) $(SHARED_FLAGS) -o $@ $^ $(LIBDEPS)

install: $(LIBS)
	$(Q)$(INSTALL_PROGRAM) -m 755 libprio*.so $(DESTDIR)$(plugindir)

uninstall:
	$(Q)for file in $(LIBS); do $(RM) $(DESTDIR)$(plugindir)/$$file; done

clean: dep_clean
	$(Q)$(RM) core *.a *.o *.gz *.so

OBJS = $(LIBS:libprio%.so=%.o) alua_rtpg.o
.SECONDARY: $(OBJS)

include $(wildcard $(OBJS:.o=.d))

dep_clean:
	$(Q)$(RM) $(OBJS:.o=.d)

=== debian/changelog ===
multipath-tools (0.9.9-1) unstable; urgency=medium

  [ mitchdz ]
  * [14083d6] d/t/tgtbasedmpaths: do not brace expand as systemd does
    not understand (Closes: #1074403)

  [ Chris Hofstaedtler ]
  * [b5fef17] New upstream version 0.9.9
  * [ef49180] Rebase patches

 -- Chris Hofstaedtler <zeha@debian.org>  Sun, 07 Jul 2024 01:58:32 +0200

multipath-tools (0.9.8-1) unstable; urgency=medium

  [ mitchdz ]
  * [9ffd042] tgtbasedmpaths: also check status of the socket (Closes:
    #1069680)

  [ Chris Hofstaedtler ]
  * [6f82765] New upstream version 0.9.8
  * [7e41b68] Refresh patches
  * [7119712] Revert "Implement real socket activation of multipathd.service."
    Unsupported upstream.
  * [551f721] Install new udev rules.

 -- Chris Hofstaedtler <zeha@debian.org>  Thu, 13 Jun 2024 02:44:49 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: multipath-tools
 Section: admin
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian DM Multipath Team <team+linux-blocks@tracker.debian.org>
+Maintainer: Debian DM Multipath Team <team+linux-blocks@tracker.debian.org>
 Uploaders:
  Guido Günther <agx@sigxcpu.org>,
  Ritesh Raj Sarraf <rrs@debian.org>,
@@ -61,18 +60,10 @@
  It is part of the Linux multipath-tools, but is useful on any
  device-mapper using system.
 
-Package: kpartx-boot
-Architecture: all
-Depends: ${misc:Depends}, initramfs-tools,
- kpartx (>= ${source:Version}), kpartx (<< ${source:Version}.1~)
-Description: Provides kpartx during boot
- This package makes kpartx available during boot to activate partitions
-
 Package: multipath-tools-boot
 Architecture: all
 Depends:
  initramfs-tools | linux-initramfs-tool,
- kpartx-boot (= ${binary:Version}),
  multipath-tools (<< ${source:Version}.1~),
  multipath-tools (>= ${source:Version}),
  ${misc:Depends},

=== debian/rules ===
--- 
+++ 
@@ -1,12 +1,7 @@
 #!/usr/bin/make -f
-
-ifeq ($(shell dpkg-architecture -qDEB_HOST_ARCH),i386)
-	skip_packages = -Nmultipath-tools
-endif
 
 # For Hardening
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
-export DEB_LDFLAGS_MAINT_STRIP=-Wl,-Bsymbolic-functions
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/buildflags.mk
 include /usr/share/dpkg/pkg-info.mk
@@ -50,9 +45,6 @@
 	dh_auto_install --sourcedirectory=debian/build-deb -- DESTDIR=$(CURDIR)/debian/tmp/deb
 	dh_auto_install --sourcedirectory=debian/build-udeb -- DESTDIR=$(CURDIR)/debian/tmp/udeb
 
-	mkdir -p $(CURDIR)/debian/tmp/deb/etc
-	cp debian/multipath.conf $(CURDIR)/debian/tmp/deb/etc
-
 	# udebs dont get manpages
 	rm -rf $(CURDIR)/debian/tmp/udeb/usr/share/man
 
@@ -75,26 +67,9 @@
 override_dh_bugfiles:
 	dh_bugfiles -A -pmultipath-tools -pmultipath-tools-boot
 
-override_dh_installudev:
-	dh_installudev -pkpartx --priority=95
-	dh_installudev -pkpartx --name=dm-parts --priority=56
-	dh_installudev -pkpartx --name=del-part-nodes --priority=68
-	dh_installudev -pmultipath-tools --name=multipath
-	dh_installudev -pmultipath-tools --name=dm-mpath --priority=56
-
 override_dh_installsystemd:
-	# Don't auto-enable/start the service; instead, rely on
-	# socket-activation.
 	dh_installsystemd -pmultipath-tools multipathd.service \
-		--no-stop-on-upgrade --no-enable
-	dh_installsystemd -pmultipath-tools multipathd.socket
+		--no-stop-on-upgrade
 
 override_dh_makeshlibs:
 	dh_makeshlibs -a --add-udeb=multipath-udeb
-
-override_dh_builddeb:
-	dh_builddeb ${skip_packages}
-
-override_dh_gencontrol:
-	dh_gencontrol ${skip_packages}
-

=== debian/tests/control ===
Tests: kpartx-file-loopback
Depends:
 gdisk,
 kpartx,
 qemu-utils,
Restrictions: needs-root, isolation-machine

Tests: tgtbasedmpaths
Depends:
 fio,
 lsscsi,
 multipath-tools,
 open-iscsi,
 tgt,
Restrictions: needs-root, isolation-machine, allow-stderr

Tests: initramfs
Architecture: amd64 arm64
Depends:
 multipath-tools,
 multipath-tools-boot,
 linux-image-amd64 | linux-image-arm64,
 initramfs-tools,
Restrictions: needs-root, allow-stderr

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/multipath-tools-$1\.tar\.gz/ \
  https://github.com/opensvc/multipath-tools/tags .*/v?(\d\S+)\.tar\.gz
